/*
 * Spiele programmieren mit Java ME
 * von Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */
import java.util.Random;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.game.GameCanvas;

/**
 * Komplette Version des Spiels PING
 * @author Gerhard Vlkl
 */
public class PingCanvas extends GameCanvas implements Runnable{
    
    private Thread gameLoop;
    private Ping midlet;
    private static int SPEED = 4;
    private int points=0;
    
    private int ballX;
    private int ballY;
    private static final int BALLLENGTH    =4;
    private static final int BALLHALFLENGTH=BALLLENGTH/2;
    private int ballSpeedX;
    private int ballSpeedY;
	
    private int paddleX;
    private int paddleY;
    private static final int PADDLELENGTH=20;
    private static final int PADDLEHALFLENGTH=PADDLELENGTH/2;
    private static final int PADDLEHEIGHT=4;
    private static final int PADDLEHALFHEIGTH=PADDLEHEIGHT/2;
    private int paddleSpeedX;
	
    private double turndegree = 16 * Math.PI/180;
    private float cos_degree = (float) Math.cos(turndegree);
    private float sin_degree = (float) Math.sin(turndegree);

    


	
    protected PingCanvas(Ping aMidlet) {
        super(true); //true: Key-Events unterdrcken
	midlet = aMidlet;
	init();
    }


    private void init(){
	ballX = getWidth()/2;
	ballY = getHeight()/2;
                
        Random random = new Random();
        double degree = Math.abs(random.nextInt()%90)+45;
                
        ballSpeedX=(int)Math.floor(Math.cos(Math.toRadians(degree))*SPEED);
        ballSpeedY=(int)Math.floor(Math.sin(Math.toRadians(degree))*SPEED);
                	
	paddleX = getWidth()/2;
	paddleY = getHeight()-PADDLEHALFHEIGTH;
	paddleSpeedX=6;
        
        points = 0;
    }
	
	protected void showNotify(){
		gameLoop = new Thread(this);
		gameLoop.start();
	}
	
	protected void hideNotify(){
		gameLoop = null;
	}
	
	
	public void run() {
		Graphics g = getGraphics();
		Thread t = Thread.currentThread();
		
		while(t==gameLoop){
			move(getKeyStates());
			render(g);
			flushGraphics();
                        
			// etwas warten, damit andere auch dran kommen
			try { Thread.sleep(48); }
			catch (InterruptedException ie) {}
		}
	}

	private void render(Graphics g) {
                // Zeichenflche lschen
		g.setColor(0xffffff);
		g.fillRect(0,0,getWidth(),getHeight());
		
                // Ball zeichnen
		g.setColor(0x0000ff);
		g.fillRect(ballX-BALLHALFLENGTH,
		           ballY-BALLHALFLENGTH,
			   BALLLENGTH,
		           BALLLENGTH);
                
                // Schlger zeichnen
		g.fillRect(paddleX-PADDLEHALFLENGTH,
		           paddleY-PADDLEHALFHEIGTH,
			   PADDLELENGTH,
			   PADDLEHEIGHT);
                
                //Anzeige
                g.drawString("Punkte: " + points,0,0,Graphics.TOP | Graphics.LEFT);
	}

	private void move(int keyStates) {
		
		//Tastendruck verarbeiten
		if ((keyStates & FIRE_PRESSED)!=0){
			midlet.quit();
		}
		if ((keyStates & UP_PRESSED)!=0){
		}
		if ((keyStates & LEFT_PRESSED)!=0){
			paddleX = Math.max(PADDLEHALFLENGTH,paddleX-paddleSpeedX);
		}
		if ((keyStates & RIGHT_PRESSED)!=0){
			paddleX = Math.min(getWidth()-PADDLEHALFLENGTH,paddleX+paddleSpeedX);
		}
		
		//Ball bewegen
		ballX += ballSpeedX;
		ballY += ballSpeedY;
		
		//Ball springt oben zurck
		if(ballY-BALLLENGTH <=0){
			ballY=BALLLENGTH;
			ballSpeedY *=-1;
                        points+=1;
			turnALittle();
		}
		
		//Ball linke und rechte Bande
		if(ballX<=BALLHALFLENGTH || ballX >=getWidth()-BALLHALFLENGTH){
                    ballX = Math.max(BALLHALFLENGTH,ballX);
                    ballX = Math.min(getWidth()-BALLHALFLENGTH,ballX);
                    ballSpeedX *=-1;
                    points+=1;
		}
		
		//Ball fliegt unten ins Aus
		if(ballY>=getHeight()){
			init();
		}
		
		//Ball trifft auf Schlger
		if(ballY>=getHeight()-PADDLEHEIGHT){
			if(ballX>=paddleX-PADDLEHALFLENGTH){
				if(ballX<=paddleX+PADDLEHALFLENGTH){
					ballSpeedY *=-1;
				}
			}
		}
		
		
	}

	private void turnALittle(){
		float x = ballSpeedX;
		float y = ballSpeedY;
	//	ballSpeedX = x * cos_degree + y * sin_degree;
	//	ballSpeedY = y * cos_degree + x * sin_degree;
	}
}
