/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.game.GameCanvas;
import javax.microedition.midlet.MIDlet;

/**
 * Version 4 von PING
 * @author Gerhard Vlkl
 */        
public class PingCanvas extends GameCanvas 
                        implements Runnable{
    
    /**** Spiel-Model - Start ****/
    private int ballX;
    private int ballY;
    private int ballSpeedX;
    private int ballSpeedY;
    
    private int points;  
    private int paddleX;
    private int paddleY;
    private int paddleSpeedX;
    /**** Spiel-Model - Ende ****/
    
    private static final int BALLLENGTH    =4;
    private static final int BALLHALFLENGTH=BALLLENGTH/2;  
    private static final int PADDLELENGTH=20;
    private static final int PADDLEHALFLENGTH=PADDLELENGTH/2;
    private static final int PADDLEHEIGHT=4;
    private static final int PADDLEHALFHEIGTH=PADDLEHEIGHT/2;
    
    private MIDlet midlet;
    private volatile Thread gameLoop;
    
    public PingCanvas(MIDlet aMIDlet){
        super(true); //true: Key-Events unterdrcken
        midlet = aMIDlet;
	init();
    }

    private void init(){
	ballX = getWidth()/2;
	ballY = getHeight()/2;
        ballSpeedX=4;
        ballSpeedY=4;
        
        paddleX = getWidth()/2;
	paddleY = getHeight()-PADDLEHALFHEIGTH;
        paddleSpeedX=6;
        points=0;
    }
    
    protected void showNotify(){
        gameLoop = new Thread(this);
	gameLoop.start();
    }
	
    protected void hideNotify(){
	gameLoop = null;
    }
    
   public void run() {
	Graphics g = getGraphics();
	Thread t = Thread.currentThread();
		
	while(t==gameLoop){
            update(getKeyStates());
            render(g);
            flushGraphics();
                        
            // etwas warten, damit andere auch dran kommen
            try { Thread.sleep(48); }
                  catch (InterruptedException ie) {}
            }
    }
    
    private void update(int keyStates){
        //Tastendruck verarbeiten
	if ((keyStates & FIRE_PRESSED)!=0){
            ((Ping)midlet).quit();
	}
	if ((keyStates & UP_PRESSED)!=0){
	}
	if ((keyStates & LEFT_PRESSED)!=0){
            paddleX = Math.max(PADDLEHALFLENGTH,paddleX-paddleSpeedX);
	}
	if ((keyStates & RIGHT_PRESSED)!=0){
            paddleX = Math.min(getWidth()-PADDLEHALFLENGTH,paddleX+paddleSpeedX);
	} 
        
       //Ball bewegen
	ballX += ballSpeedX;
	ballY += ballSpeedY;
        
        //Ball springt oben zurck
		if(ballY-BALLLENGTH <=0){
			ballY=BALLLENGTH;
			ballSpeedY *=-1;
                        points+=1;

		}
		
		//Ball linke und rechte Bande
		if(ballX<=BALLHALFLENGTH || ballX >=getWidth()-BALLHALFLENGTH){
                    ballX = Math.max(BALLHALFLENGTH,ballX);
                    ballX = Math.min(getWidth()-BALLHALFLENGTH,ballX);
                    ballSpeedX *=-1;
                    points+=1;
		}
		
		//Ball fliegt unten ins Aus
		if(ballY>=getHeight()){
			init();
		}
		
		//Ball trifft auf Schlger
		if(ballY>=getHeight()-PADDLEHEIGHT){
			if(ballX>=paddleX-PADDLEHALFLENGTH){
				if(ballX<=paddleX+PADDLEHALFLENGTH){
					ballSpeedY *=-1;
				}
			}
		}
    }
    
    
   private void render(Graphics g) {
       
        // Zeichenflche lschen
	g.setColor(0xffffff);
	g.fillRect(0,0,getWidth(),getHeight());
		
                // Ball zeichnen
	g.setColor(0x0000ff);  //Farbe soll Blau sein
	g.fillRect(ballX-BALLHALFLENGTH, 
		   ballY-BALLHALFLENGTH,
	           BALLLENGTH,
		   BALLLENGTH);
         // Schlger zeichnen
		g.fillRect(paddleX-PADDLEHALFLENGTH,
		           paddleY-PADDLEHALFHEIGTH,
			   PADDLELENGTH,
			   PADDLEHEIGHT);
               
        //Anzeige
        g.drawString("Punkte: " + points,0,0,Graphics.TOP | Graphics.LEFT);
    }  
}