/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */
package mgame;

import java.io.IOException;
import javax.microedition.midlet.MIDlet;
import mgame.ui.GameDialog;
import mgame.ui.UiManager;

/**
 * FreddyTheFish mit GUI
 * @author Gerhard Vlkl
 */
public abstract class Game {

    public UiManager uiManager;
    public HighScoreManager highScoreManager;
    public MIDlet midlet;
    private GameDialog gameDialog=null;
    
    public Game(MIDlet midlet) {
        this.midlet = midlet;
        uiManager = new UiManager(this);
        highScoreManager = new HighScoreManager(this);
    }
    
    public void restartGame(){
       uiManager.showGameDialog();
    }
    
    public boolean isRunning(){
        if (gameDialog==null) return false;
        
        return (gameDialog.getGameState()==GameDialog.STATE_RUN);
    }

    public void exitGame() {
	//midlet.destroyApp(false);
	midlet.notifyDestroyed();
    }

    public void startNewGame(boolean multiuser) {
        try{
            gameDialog = getNewGameDialog();
            uiManager.setGameDialog(gameDialog);
            uiManager.showGameDialog();
	} catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    protected abstract GameDialog getNewGameDialog() throws IOException;
}
