/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */
package mgame.ui;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.TextBox;
import javax.microedition.lcdui.TextField;

/**
 * FreddyTheFish mit GUI
 * @author Gerhard Vlkl
 */
public class HelpTextDialog extends TextBox implements CommandListener{
    
    private UiManager uiManager;
    private Command backCommand=null;
    
    public HelpTextDialog(UiManager uiManager) {
        super("Anleitung",null,1,TextField.ANY|TextField.UNEDITABLE);
        this.uiManager = uiManager;
        backCommand= new Command("Zurck",Command.BACK,1);
        addCommand(backCommand);
        setCommandListener(this);
    }
    
    public void setText(String text){
        setMaxSize(text.length());
        setString(text);
    }

    public void commandAction(Command command, Displayable displayable) {
        if (displayable!=this) return;
        
        if(command==backCommand){
            uiManager.showHelpDialog();
        }
    }
}
