/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */

package mgame.ui;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.List;

/**
 * FreddyTheFish mit Audio
 * @author Gerhard Vlkl
 */
public class OptionDialog extends List implements CommandListener{
    
   private UiManager uiManager = null;
    
    private static final String OPTION1="Musik";
    private static final String OPTION2="Lautstrke";
    private static final String OPTION3="OPTION 3";
    private static final String OPTION4="OPTION 4";
    
    private Command selectCommand=null;
    private Command backCommand=null;
    
    public OptionDialog(UiManager uiManager) {
        super(uiManager.OPTIONS,List.IMPLICIT,new String[]{OPTION1,OPTION2,
                                                           OPTION3,OPTION4},null);
        this.uiManager = uiManager;
        
        selectCommand = new Command(uiManager.SELECT,Command.ITEM,1);
        addCommand(selectCommand);
        backCommand= new Command(uiManager.BACK,Command.BACK,2);
        addCommand(backCommand);
        setCommandListener(this);
    }
    
    public void commandAction(Command command, Displayable displayable) {
        if (displayable!=this) return;
        
        if (command==selectCommand){
            String selectedItem = this.getString(this.getSelectedIndex());
            if (selectedItem.equals(OPTION1)){
                uiManager.showOptionMusic();
            }
            else if (selectedItem.equals(OPTION2)){
                uiManager.showOptionVolume();
            }
        }else if(command==backCommand){
            uiManager.showMainDialog();
        }
    }
    
}
