/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.game.GameCanvas;
import javax.microedition.lcdui.game.Sprite;

/**
 * FreddyTheFish mit Audio
 * @author Gerhard Vlkl
 */
public class FishActor extends Sprite {
    
    private int speed=0;
    private int minX;
    private int minY; 
    private int maxX; 
    private int maxY;

    private int lastX;
    private int lastY;
    
    public FishActor(Image image) {
        super(image);
        defineReferencePixel(getWidth()/2,getHeight()/2);
    }   

    void setSpeed(int aSpeed) {
        speed = aSpeed;
    }

    void setBorders(int aMinX, int aMinY, int aMaxX, int aMaxY) {
        minX=aMinX;
        minY=aMinY; 
        maxX=aMaxX; 
        maxY=aMaxY;
    }

    public void setPosition(int x, int y){
        lastX = getX();
        lastY = getY();
        super.setPosition(x,y);    
    }
    
    void setLastPosition() {
        super.setPosition(lastX,lastY);
    }
    void update(int keyStates) {
        if((keyStates & GameCanvas.RIGHT_PRESSED)!=0){
           setPosition(Math.min(getX()+speed,maxX-getWidth()),
                        getY());
	   setTransform(Sprite.TRANS_NONE);
	}
        else if((keyStates & GameCanvas.LEFT_PRESSED)!=0){
            setPosition(Math.max(getX()-speed,minX),
	   		getY());
            setTransform(Sprite.TRANS_MIRROR);
	}
        else if((keyStates & GameCanvas.UP_PRESSED)!=0){
            setPosition(getX(),Math.max(getY()-speed,minY));
	}
        else if ((keyStates & GameCanvas.DOWN_PRESSED)!=0){
            setPosition(getX(),Math.min(getY()+speed,
			maxY-getHeight()));
	}
    }
}
