/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */
package mgame.ui;

import java.io.IOException;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.media.Manager;
import javax.microedition.media.MediaException;
import javax.microedition.media.Player;
import javax.microedition.media.control.MIDIControl;

/**
 * FreddyTheFish mit Audio
 * @author Gerhard Vlkl
 */
public class SystemInfoDialog extends Form implements CommandListener{
        
    private UiManager uiManager;
    private Command backCommand=null;
        
    public SystemInfoDialog(UiManager uiManager) {
        super("Info");
        this.uiManager = uiManager;
        backCommand = new Command(uiManager.BACK,Command.BACK,2);
        addCommand(backCommand);
        setCommandListener(this);
        
        //Audio
        append("Audio:\n");
        String audioApi = System.getProperty("microedition.media.version");
        if(audioApi==null){
            append("No Audio\n");
        }else{
            append("  MM API Version:" + audioApi + "\n");
            String ammsApi = System.getProperty("microedition.amms.version");
            if (ammsApi==null){
                append("  No AMMS API");
            }
            else{
                append("  Advanced Multimedia Supplements Version:"+ammsApi+"\n");
            }
            append("  Mixing Supported:" + System.getProperty("supports.mixing") + "\n");
            append("  Content Types:\n");
            String contentTypes[]=Manager.getSupportedContentTypes(null);
            boolean isMIDIAvailable = false;
            for(int i=0;i<contentTypes.length;i++){
                if(contentTypes[i].startsWith("audio")){
                    append("    " + contentTypes[i] + "\n");
                    isMIDIAvailable = contentTypes[i].endsWith("midi");
                }
            }
            if(isMIDIAvailable){
                try {
                    Player p = Manager.createPlayer(Manager.MIDI_DEVICE_LOCATOR);
                    p.prefetch(); //Open Device
                    MIDIControl m = (MIDIControl)p.getControl("MIDIControl");
                    if(m.isBankQuerySupported()){
                        int bankList[] = m.getBankList(false);
                        for(int i=0;i<bankList.length;i++){
                            append("    Bank " + String.valueOf(bankList[i])+"\n");
                            int programList[] = m.getProgramList(bankList[i]);
                            for(int j=0;j<programList.length;j++){
                                append("      "+m.getProgramName(bankList[i],programList[j])+"\n");
                            }
                        }
                     //   for(int i=0;i<=15;i++){
                     //       append("C" + String.valueOf(i)+" "+String.valueOf(m.getProgram(i)));
                     //   }
                    }
                } catch (IOException ex) {
                    ex.printStackTrace();
                } catch (MediaException ex) {
                    ex.printStackTrace();
                }
            }
        }
    }

    public void commandAction(Command command, Displayable displayable) {
        if (command == backCommand && displayable == this) {
            uiManager.showMainDialog();
	}
    }
    
}
