/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */
import java.io.IOException;
import java.io.InputStream;
import java.util.Timer;
import javax.microedition.amms.GlobalManager;
import javax.microedition.amms.SoundSource3D;
import javax.microedition.amms.Spectator;
import javax.microedition.amms.control.audio3d.CommitControl;
import javax.microedition.amms.control.audio3d.DopplerControl;
import javax.microedition.amms.control.audio3d.LocationControl;
import javax.microedition.amms.control.audioeffect.ReverbControl;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.media.Manager;
import javax.microedition.media.MediaException;
import javax.microedition.media.Player;

/**
 * Soundsamples
 * @author Gerhard Vlkl
 */
public class ThreeDDialog extends Form implements CommandListener{
    
    private MenuDialog dialog;
    private Timer timer;
    
    public SoundSource3D carSound;
    public int carX=-200000;  // in mm
    public int carY=0;
    public int carZ=-5000;
    public int carVx=44444; // in mm/s
    public int carVy=0;
    public int carVz=0;
    public static final int PERIOD=50; //MilliSec
    
    private Player carPlayer;
    private UpdateTask updateTask;
    
    public ThreeDDialog(MenuDialog menuDialog)  {
        super("3D-Audio");
        this.dialog = menuDialog;
        addCommand(new Command("Zurck",Command.BACK,2));
        setCommandListener(this);
        
        //Audio
        String ammsApi = System.getProperty("microedition.amms.version");
        if (ammsApi==null){
            append("  No AMMS API");
        } else{
            append("  Advanced Multimedia Supplements Version:"+ammsApi+"\n");
            initAudio();
            updateTask = new UpdateTask(this);
            timer = new Timer();
            timer.schedule(updateTask,0,PERIOD);
        }    
    }
    
    private void initAudio(){
        try {
            
            InputStream is = getClass().getResourceAsStream("/car.wav");
            carPlayer = Manager.createPlayer(is,"audio/x-wav");
            carPlayer.realize();
            carPlayer.setLoopCount(-1);
            
            carSound = GlobalManager.createSoundSource3D();
            carSound.addPlayer(carPlayer);
            
            LocationControl locCar = (LocationControl) carSound.getControl("javax.microedition.amms.control.audio3d.LocationControl");
            locCar.setCartesian(carX,carY,carZ);
            
            DopplerControl docCar = (DopplerControl) carSound.getControl("javax.microedition.amms.control.audio3d.DopplerControl");
            docCar.setVelocityCartesian(carVx, carVy, carVz);
            docCar.setEnabled(true);
            
            Spectator spectator = GlobalManager.getSpectator();
            LocationControl locSpectator = (LocationControl) carSound.getControl("javax.microedition.amms.control.audio3d.LocationControl");
            locSpectator.setCartesian(0,0,0);
            
            ReverbControl reverb = (ReverbControl) GlobalManager.getControl("javax.microedition.amms.control.audioeffect.ReverbControl");
            reverb.setPreset("alley");
            reverb.setEnabled(true);
            
            CommitControl commitControl = (CommitControl) GlobalManager.getControl("javax.microedition.amms.control.audio3d.CommitControl");
            commitControl.setDeferred(true);
            
            carPlayer.start();
            
        } catch (IOException ex) {
            ex.printStackTrace();
        } catch (MediaException ex) {
            ex.printStackTrace();
        }
    }
    
    public void commandAction(Command command, Displayable displayable) {
        if(displayable!=this) return;
        timer.cancel();
        try {
            carPlayer.stop();
        } catch (MediaException ex) {
            ex.printStackTrace();
        }
        Display.getDisplay(dialog.midlet).setCurrent(dialog);
    }
}