/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */
import java.util.TimerTask;
import javax.microedition.amms.GlobalManager;
import javax.microedition.amms.control.audio3d.CommitControl;
import javax.microedition.amms.control.audio3d.DopplerControl;
import javax.microedition.amms.control.audio3d.LocationControl;

/**
 * Soundsamples
 * @author Gerhard Vlkl
 */
public class UpdateTask extends TimerTask{
    
    private ThreeDDialog gameObject;
    private CommitControl commitControl;
    
    /** Creates a new instance of UpdateTask */
    public UpdateTask(ThreeDDialog threeDDialog) {
        this.gameObject = threeDDialog;
    }
    
    private void update(){
        gameObject.carX += gameObject.PERIOD * gameObject.carVx/1000;
        gameObject.carY += gameObject.PERIOD * gameObject.carVy/1000;
        gameObject.carZ += gameObject.PERIOD * gameObject.carVz/1000;
    }
    
    private void renderAudio(){
        if(commitControl==null){
            commitControl = (CommitControl) GlobalManager.getControl("javax.microedition.amms.control.audio3d.CommitControl");
            commitControl.setDeferred(true);
        }
        LocationControl locCar = (LocationControl) gameObject.carSound.getControl("javax.microedition.amms.control.audio3d.LocationControl");
        locCar.setCartesian(gameObject.carX,gameObject.carY,gameObject.carZ);
        
        DopplerControl docCar = (DopplerControl) gameObject.carSound.getControl("javax.microedition.amms.control.audio3d.DopplerControl");
        docCar.setVelocityCartesian(gameObject.carVx, gameObject.carVy, gameObject.carVz);
        
        commitControl.commit();
    }
    
    public void run() {
        update();
        renderAudio();
    }
    
}
