/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.media.Manager;

/**
 * Soundsamples
 * @author Gerhard Vlkl
 */
public class InfoDialog extends Form implements CommandListener{
    
    private MenuDialog dialog;
    
    public InfoDialog(MenuDialog menuDialog) {
        super("Info");
        this.dialog = menuDialog;
        addCommand(new Command("Zurck",Command.BACK,2));
        setCommandListener(this);
        
        //Audio
        append("Audio:\n");
        String audioApi = System.getProperty("microedition.media.version");
        if(audioApi==null){
            append("No Audio\n");
        }else{
            String ammsApi = System.getProperty("microedition.amms.version");
            if (ammsApi==null){
                append("  No AMMS API");
            }
            else{
                append("  Advanced Multimedia Supplements Version:"+ammsApi+"\n");
            }
            append("  MM API Version:" + audioApi + "\n");
            append("  Mixing Supported:" + System.getProperty("supports.mixing") + "\n");
            append("  Content Types:\n");
            String contentTypes[]=Manager.getSupportedContentTypes(null);
            for(int i=0;i<contentTypes.length;i++){
                append("    " + contentTypes[i] + "\n");
                String protocols[]=Manager.getSupportedProtocols(contentTypes[i]);
                for(int j=0;j<protocols.length;j++){
                    append("        "+protocols[j]+"\n");
                }
                
            }
            
        }
    }
    
    public void commandAction(Command command, Displayable displayable) {
        if(displayable!=this) return;
        Display.getDisplay(dialog.midlet).setCurrent(dialog);
    }
}