import javax.microedition.midlet.MIDlet;
/*
 * Game.java
 *
 * Created on 27. August 2006, 17:36
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author Gerhard
 */
public class Game implements IMIDletFacade, Runnable{
    
    private MIDlet midlet;
    private boolean isInit=false;
    Thread gameLoop=null;
    private static final int MILLIS_PER_TICK = 50;

    private ModelManager modelManager;
    private ControlManager controlManager;
    private ViewManager viewManager;
    
    /**
     * Creates a new instance of Game
     */
    public Game(MIDlet aMIDlet) {
        midlet = aMIDlet;
    }

    private void init(){
        modelManager = new ModelManager();
        controlManager = new ControlManager();
        viewManager = new ViewManager(this);
    }
    
    // --------- MIDletFacade
    public void startGame() {
        if(isInit){
            init();
            isInit=true;
        }
    }

    public void pauseGame() {
    }

    public void destroyGame(boolean unconditional) {
    }

    // --------- Die Spiele-Schleife
    public void startNotify(){
	gameLoop = new Thread(this);
	gameLoop.start();
    }
	
    public void stopNotify(){
	gameLoop = null;
    }
    
    public void run() {
	Thread t = Thread.currentThread();
		
	while(t==gameLoop){
            long startTime = System.currentTimeMillis();
            
            viewManager.render();
            
            controlManager.move();
            
            long timeTaken = System.currentTimeMillis() - startTime;
			
            if (timeTaken < MILLIS_PER_TICK) { // etwas warten, damit andere auch dran kommen
                try{ Thread.sleep(MILLIS_PER_TICK - timeTaken);}
                catch (InterruptedException ex){};
            }
        }
    }
    
}
