/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */

import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.StringItem;
import javax.microedition.location.Coordinates;
import javax.microedition.location.Criteria;
import javax.microedition.location.Location;
import javax.microedition.location.LocationListener;
import javax.microedition.location.LocationProvider;
import javax.microedition.location.Orientation;
import javax.microedition.midlet.MIDlet;

/**
 * Location Sample
 * @author Gerhard Vlkl
 */
public class LocationDialog extends Form implements CommandListener, LocationListener{
    
    private MIDlet midlet;
    private StringItem positionItem;
    private StringItem stateItem;
    
    public LocationDialog(MIDlet midlet) {
        super("Info");
        this.midlet = midlet;
        
        addCommand(new Command("ENDE",Command.BACK,2));
        setCommandListener(this);
        
        //Location Based
        append("Location API:  ");
        String locationApi = System.getProperty("microedition.location.version");
         if(locationApi==null){
            append("No Location API\n");
        }else{
            append("Version:"+locationApi+"\n");
            try {
                Criteria cr = new Criteria();
                cr.setCostAllowed(true);
                LocationProvider lp = LocationProvider.getInstance(cr);
                Location l = lp.getLocation(10);
                Coordinates c = l.getQualifiedCoordinates();
                append("    Coordinates:\n");
                append("        Altitude  "+c.getAltitude()+"\n");
                append("        Latitude  "+c.getLatitude()+"\n");
                append("        Longitude "+c.getLongitude()+"\n");
                
                append("    Methode:\n");
                int method = l.getLocationMethod();
                append(((method & Location.MTA_ASSISTED)!=0) ? "assisted" : "unassisted");
                append(((method & Location.MTE_ANGLEOFARRIVAL)!=0)?"AngleOfArrival":"");
                append(((method & Location.MTE_CELLID)!=0)?"CellID":"");
                append(((method & Location.MTE_SATELLITE)!=0)?"Satellite":"");
                append(((method & Location.MTE_SHORTRANGE)!=0)?"ShortRange":"");
                append(((method & Location.MTE_TIMEDIFFERENCE)!=0)?"TimeDifference":"");
                append(((method & Location.MTE_TIMEOFARRIVAL)!=0)?"TimeOfArrival":"");
                append(((method & Location.MTY_NETWORKBASED)!=0)?"NetworkBased\n":"TerminalBased\n");
                
                Orientation o = Orientation.getOrientation();
                append("    Orientation:\n");
                append("        Azimuth:"+o.getCompassAzimuth()+"\n");
                append("        Roll:"+o.getRoll()+"\n");
                append("        Pitch:"+o.getPitch()+"\n");
                
                positionItem = new StringItem("Akt. Position:",
                                    "", StringItem.PLAIN);
                append(positionItem);
                stateItem = new StringItem("State:",
                                    "", StringItem.PLAIN);
                append(stateItem);
                lp.setLocationListener(this,-1,0,0); //Default
                
            } catch (Exception ex) {
            Alert info = new Alert("Exception",ex.toString(),null,null);
            info.setTimeout(Alert.FOREVER);
            Display.getDisplay(midlet).setCurrent(info);
            }    
        }
    }

    public void commandAction(Command command, Displayable displayable) {
         if(displayable!=this) return;
         midlet.notifyDestroyed();
    }

    public void locationUpdated(LocationProvider locationProvider, Location location) {
        Coordinates c = location.getQualifiedCoordinates();
        positionItem.setText(c.getLongitude()+" "+c.getLatitude());
    }

    public void providerStateChanged(LocationProvider locationProvider, int i) {
        switch(i){
            case LocationProvider.AVAILABLE:
                stateItem.setText("AVAILABLE"); break;
            case LocationProvider.OUT_OF_SERVICE:
                stateItem.setText("OUT_OF_SERVICE"); break;
            case LocationProvider.TEMPORARILY_UNAVAILABLE:
                stateItem.setText("TEMPORARILY_UNAVAILABLE"); break;
        }
    }
    
}
