/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */

package mgame;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

/**
 * NelsonFlow
 * @author Gerhard Vlkl
 */
public class HighScoreRecord {

    public long score;
    public String name;
    
    public HighScoreRecord() {
    }

    public void setBytes(byte[] record) throws IOException {
        ByteArrayInputStream bais = new ByteArrayInputStream(record);
        DataInputStream dis = new DataInputStream(bais);
        
        score = dis.readLong();
        name = dis.readUTF();
        
        dis.close();
    }
    
    public byte[] getBytes() throws IOException{
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        DataOutputStream das = new DataOutputStream(baos);
        das.writeLong(score);
        das.writeUTF(name);
        das.close();
        return baos.toByteArray();
    }
 
    public String toString(){
         return name + "(" + String.valueOf(score) + ")" ;
    }
}
