/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */

package mgame.ui;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.game.GameCanvas;
import javax.microedition.lcdui.CommandListener;
import mgame.Game;

/**
 * NelsonFlow
 * @author Gerhard Vlkl
 */
public class GameDialog extends GameCanvas implements CommandListener {
    Command backCommand;
    protected Game game;
    
    public static final int STATE_START=0;
    public static final int STATE_RUN=1;
    public static final int STATE_LOST=3;
    public static final int STATE_WIN=4;
    public static final int STATE_INTERRUPTED=5;
    
    protected int gameState;
    protected boolean multiuser;

    public GameDialog(Game game, boolean multiuser) {
        super(true); //true: Key-Events unterdrcken
        this.game = game; //c
        this.multiuser = multiuser;
        backCommand = new Command("Zurck",Command.BACK,1); //c
        addCommand(backCommand);
        setCommandListener(this);
    }
    
    public void commandAction(Command command, Displayable displayable) {
        if (displayable!=this) return;
        
        if (command==backCommand){
            game.uiManager.showMainDialog();
        }
    }
    
     protected void initFirstCall(){
        if (multiuser){
            setState(STATE_START);
            game.communityManager.netSynchronizer.starting();
        }else{
            setState(STATE_RUN);
        }
    }
    
    public synchronized void setState(int state) {
       this.gameState=state;
    }
    public synchronized int getState(){
        return this.gameState;
    }
    
    public synchronized void setLeader(boolean isLeader){
        
    }

    public void setOpponentPosition(int x, int y) {
    }

}
