/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */

package mgame.ui;

import javax.microedition.lcdui.ChoiceGroup;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Gauge;
import javax.microedition.lcdui.TextField;

/**
 * NelsonFlow
 * @author Gerhard Vlkl
 */
public class LoginDialog extends Form implements CommandListener {
    
    private UiManager uiManager;
    
    private Command exitCommand=null;
    private Command loginCommand=null;
    
    private TextField user;
    private TextField password;
    private ChoiceGroup remember;
    private Gauge warten;
            
    public LoginDialog(UiManager uiManager) {
        super("Login-Dialog");
        this.uiManager = uiManager;
        
        user = new TextField("UserID: ","test1",16,TextField.ANY);
        append(user);
        password = new TextField("Passwort: ","test",16,TextField.PASSWORD);
        append(password);
        remember = new ChoiceGroup("Passwort merken?",ChoiceGroup.MULTIPLE);
        remember.append("Ja/Nein",null);
        append(remember);
        
        exitCommand = new Command(uiManager.EXIT,Command.EXIT,2);
        addCommand(exitCommand);
        loginCommand = new Command(uiManager.LOGIN,Command.ITEM,2);
        addCommand(loginCommand);
        setCommandListener(this);
    }
    
    public void commandAction(Command command, Displayable displayable) {
        if (displayable!=this) return;
        
        if (command==exitCommand){
            uiManager.getGame().exitGame();
        }else if (command==loginCommand){
            warten = new Gauge("",false,Gauge.INDEFINITE,Gauge.CONTINUOUS_RUNNING);
            append(warten);
            removeCommand(loginCommand);
            uiManager.getGame().communityManager.handleLogin(user.getString(),password.getString(),remember.isSelected(0),this);
        }
    }
}