/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */
package mgame.ui;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.List;

/**
 * NelsonFlow
 * @author Gerhard Vlkl
 */

public class NewGameDialog extends List implements CommandListener {
    
    private UiManager uiManager = null;
    
    private static final String STANDART="1 Spieler";
    private static final String MULTIUSER="Mitspieler";
    private static final String SELECT="Auswhl.";
    private static final String BACK="Zurck";
    
    private Command selectCommand=null;
    private Command backCommand=null;
    
    public NewGameDialog(UiManager uiManager) {
        super("Neues Spiel",List.IMPLICIT,new String[]{STANDART,MULTIUSER},null);
        this.uiManager = uiManager;
        
        selectCommand = new Command(SELECT,Command.ITEM,1);
        setSelectCommand(selectCommand);
        backCommand= new Command(BACK,Command.BACK,2);
        addCommand(backCommand);
        setCommandListener(this);
    }
    
    public void commandAction(Command command, Displayable displayable) {
        if (displayable!=this) return;
        
        if (command==selectCommand){
            String selectedItem = this.getString(this.getSelectedIndex());
            if (selectedItem==STANDART){
                uiManager.getGame().startNewGame(false);
            }else if (selectedItem==MULTIUSER){
                uiManager.getGame().startNewGame(true);
            }
        }else if(command==backCommand){
            uiManager.showMainDialog();
        }
    }
    
}
