/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */

package mgame.ui;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Gauge;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.ItemStateListener;
import mgame.OptionManager;

/**
 * NelsonFlow
 * @author Gerhard Vlkl
 */
public class OptionVolumeDialog extends Form implements CommandListener, ItemStateListener {
    
    private UiManager uiManager;
    private Command backCommand=null;
    private Gauge gauge;
    
    public OptionVolumeDialog(UiManager uiManager) {
        super("Volume");
        this.uiManager = uiManager;
        backCommand = new Command(uiManager.BACK,Command.BACK,2);
        addCommand(backCommand);
        setCommandListener(this);
        
        gauge = new Gauge("Volume:",true,100,0);
        gauge.setValue(Integer.parseInt(uiManager.getGame().optionManager.get(OptionManager.OPTION_AUDIO_VOLUME)));
        this.append(gauge);
        this.setItemStateListener(this);
    }
    
    public void commandAction(Command command, Displayable displayable) {
        if (command == backCommand && displayable == this) {
            uiManager.showOptionDialog();
        }
    }
    
    public void itemStateChanged(Item item){
        if(item==gauge){
               uiManager.getGame().setVolume(gauge.getValue());
        }
    }
}
