import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.*;


public class Cube3D extends MIDlet implements CommandListener {
	
  private final Canvas3D _MyCanvas;

  //Menpunkte
  private Command exitCommand = new Command("Exit", Command.EXIT, 99);
  private Command newCommand = new Command("Start", Command.SCREEN, 1);


  public Cube3D() {
  	_MyCanvas = new Canvas3D(this);
  	
  	_MyCanvas.addCommand(exitCommand); //Menpunkte hinzufgen
    _MyCanvas.addCommand(newCommand);
    _MyCanvas.setCommandListener(this);
  }

  public void startApp(){
    
    //Prfen, ob 3D vorhanden ist
    String lVersion = System.getProperty("microedition.m3g.version");
    if(lVersion==null){
      System.out.println("JSR-184 nicht vorhanden!");
    }
    else {
      System.out.println("JSR-184 Version " + lVersion);
    }

	_MyCanvas.start();
	
    Display.getDisplay(this).setCurrent(_MyCanvas);
  }


  public void pauseApp(){
  	_MyCanvas.stop();
  }

  public void destroyApp(boolean unconditional){
    _MyCanvas.stop();
  }

  public void quitApp(){
    _MyCanvas.stop();
    notifyDestroyed();
  }

  void newGame(){
     _MyCanvas.stop();
     _MyCanvas.init();
     Display.getDisplay(this).setCurrent(_MyCanvas);	
  }
  
  //Command-Listener
  public void commandAction(Command c, Displayable s) {
  	
    if(c == newCommand) {
    	newGame();
    } else if(c == exitCommand) {
        quitApp();
    }
  }

  
}





