import java.util.Enumeration;
import java.util.Vector;

import javax.microedition.m3g.AnimationController;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;
import javax.microedition.lcdui.*;

public class M3GViewer extends MIDlet implements CommandListener{

	private final Canvas3D _MyCanvas;
	public Display display;
	public String whatToShow="";

	private Command exitCommand = new Command("Exit", Command.EXIT, 99);
  
	
	public M3GViewer() {
		super();
		
		_MyCanvas = new Canvas3D(this);
	  	
	  	_MyCanvas.addCommand(exitCommand); 
	  	_MyCanvas.setCommandListener(this);
	}

	
	protected void startApp() throws MIDletStateChangeException {
		//Is 3D available
	    String lVersion = System.getProperty("microedition.m3g.version");
	    if(lVersion==null){
	      System.out.println("JSR-184 not available!");
	    }
	    else {
	      System.out.println("JSR-184 Version " + lVersion);
	    }
	    
	    //Show mainmenueform
	    display = Display.getDisplay(this);
	    MainMenueForm mainMenuForm = new MainMenueForm(this);
	    display.setCurrent(mainMenuForm);

	    while (whatToShow.length() == 0){}
	   
	    //InitCanvas
		_MyCanvas.init(whatToShow);
		
	    Display.getDisplay(this).setCurrent(_MyCanvas);
	}

	
	protected void pauseApp() {
		_MyCanvas.stop();
	}

	
	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {
	    _MyCanvas.stop();
	}
	
	public void quitApp(){
		_MyCanvas.stop();
	    notifyDestroyed();
	}
    
	//Command-Listener
	public void commandAction(Command c, Displayable s) {  	
	    if(c == exitCommand) {
	        quitApp();
	    }
	}
}