import java.util.Vector;

import javax.microedition.lcdui.game.GameCanvas;
import javax.microedition.m3g.AnimationController;
import javax.microedition.m3g.AnimationTrack;
import javax.microedition.m3g.Group;
import javax.microedition.m3g.Node;
import javax.microedition.m3g.SkinnedMesh;
import javax.microedition.m3g.World;

public class ActionManger {

	private Vector _Action;
	
    /**
     * 
     * @param world 
     */
	public ActionManger(World world) {
	    _Action = searchAction(world);
    	/*for (Enumeration e = v.elements();e.hasMoreElements() ;) {
			AnimationController a = (AnimationController) e.nextElement();
			System.out.print("ac="+a.getUserID());
		}*/
	    
	}

    /**
     * 
     * @param keyStates 
     * @param worldTime 
     */
	public void move(int keyStates, int worldTime) {
		if ((keyStates & GameCanvas.UP_PRESSED)!=0){
			setPosition(0,worldTime);
		}
		else if ((keyStates & GameCanvas.DOWN_PRESSED)!=0){
			setPosition(1,worldTime);
		}
		else if ((keyStates & GameCanvas.LEFT_PRESSED)!=0){
			setPosition(2,worldTime);
		}
		else if ((keyStates & GameCanvas.RIGHT_PRESSED)!=0){
			setPosition(3,worldTime);
		}
	}
	
	private void setPosition(int actionController, int worldTime){
		if(_Action.size()-1>=actionController){
			AnimationController con = (AnimationController)_Action.elementAt(actionController);
			con.setPosition(0,worldTime);
		}
	}
	
	private Vector searchAction(World world) {
		Vector v = new Vector();
		return searchAnimationController(world,v);
	}

	private Vector searchAnimationController(Node n, Vector v){ 
		
		int trackNum = n.getAnimationTrackCount();
		AnimationTrack iTrack;
		AnimationController lController;
		
		for(int i = 0; i < trackNum; i++){ 
			iTrack = n.getAnimationTrack(i); 
			lController = iTrack.getController();
			if (!v.contains(lController)){v.addElement(lController);}
		}
		
		if(n instanceof Group){ 
			int childNum = ((Group)n).getChildCount();
		
			for(int i = 0; i < childNum; i++){ 
				Node iNode = ((Group)n).getChild(i); 
				v = searchAnimationController(iNode,v); 
			} 
		}
		else if (n instanceof SkinnedMesh){
			v = searchAnimationController(((SkinnedMesh)n).getSkeleton(),v);
		}
		return v;
	} 
	
	

}
