/*
 * Created on 23.03.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

import javax.microedition.lcdui.game.GameCanvas;
import javax.microedition.m3g.*;

public class CameraExt {
	
	private Camera _Camera;
	private Group _GroupYRotation;
	private Group _GroupTranslation;
	private float _PositionX = 0.0f;
	private float _PositionY = 0.0f;
	private float _PositionZ = 0.0f;
	private float _AngleX = 0.0f;
	private float _AngleY = 0.0f;
	private ActionManger _ActionManger;
	
	private boolean _modePressed = false;
	private static final int MODE_MOVE = 0;
	private static final int MODE_ZOOM = 1;
	private static final int MODE_ROTATE = 2;
	private static final int MODE_ACTION = 3;
	
	private int _mode = MODE_MOVE;
	
	private float _StepPerSecond = 0.010f;
	private float _GradPerSecond = 0.010f;
	
	public CameraExt(Camera aCamera,Canvas3D aCanvas){
		//		Camera - Node :: X-axis rotation
		_Camera = new Camera();
		float[] lProjection = {0.0f, 0.0f, 0.0f, 0.0f};
		aCamera.getProjection(lProjection);
		_Camera.setPerspective(lProjection[0],  //Field of View
				(float)aCanvas.getWidth()/(float)aCanvas.getHeight(),
                //lProjection[1], //Aspect Ratio
                lProjection[2], //Near Clipping Plane
                lProjection[3]); //Far Clipping Plane
		_AngleX = 0;
		
		//Group - Node :: Y-axis rotation
		_GroupYRotation = new Group();
		_GroupYRotation.addChild(_Camera);
		_AngleY = 0;
		
		//Group - Node :: Translation
		_GroupTranslation = new Group();
		_PositionX = 0;
		_PositionY = 0;
		_PositionZ = 0;
		Transform lTransform= new Transform();
		aCamera.getTransform(lTransform);
		_GroupTranslation.setTransform(lTransform);
		_GroupTranslation.addChild(_GroupYRotation);
		
		//Action
		_ActionManger = new ActionManger(aCanvas.getWorld());
	}
	
	public CameraExt(float aAspectRatio,
			         float aXPos, float aYPos, float aZPos,
					 float aXRot, float aYRot){
		
		//Camera - Node :: X-axis rotation
		_Camera = new Camera();
		_Camera.setPerspective(60.0f,  //Field of View
                aAspectRatio, //Seitenverhltnis
                0.1f, //Near Clipping Plane
                1000.0f); //Far Clipping Plane
		_AngleX = aXRot;
		_Camera.setOrientation(_AngleX,1.0f,0.0f,0.0f);
		
		//Group - Node :: Y-axis rotation
		_GroupYRotation = new Group();
		_GroupYRotation.addChild(_Camera);
		_AngleY = aYRot;
		_GroupYRotation.setOrientation(_AngleY,0.0f,1.0f,0.0f);	
		
		//Group - Node :: Translation
		_GroupTranslation = new Group();
		_PositionX = aXPos;
		_PositionY = aYPos;
		_PositionZ = aZPos;
		_GroupTranslation.setTranslation(aXPos,aYPos,aZPos);
		_GroupTranslation.addChild(_GroupYRotation);

	}
	
	public Node getNode(){ return _GroupTranslation;}
	
	public Camera getCameraNode() { return _Camera;}
	
	public void move(long aTime, int aKeyStates, int worldTime){
		if ((aKeyStates & GameCanvas.FIRE_PRESSED)!=0){
			if (!_modePressed){
				_modePressed = true;
				changeMode();
			}
		}else
		{
			_modePressed = false;
		}
		
		switch(_mode){
			case MODE_MOVE: moveModeMove(aTime,aKeyStates); break;
			case MODE_ROTATE: moveModeRotate(aTime,aKeyStates); break;
			case MODE_ZOOM: moveModeZoom(aTime,aKeyStates); break;
			case MODE_ACTION:_ActionManger.move(aKeyStates,worldTime); break;
		}
	}
	
	private void moveModeMove(long aTime, int aKeyStates){
	
		if ((aKeyStates & GameCanvas.DOWN_PRESSED)!=0){
			_PositionY -= _StepPerSecond * aTime;
		}
		if ((aKeyStates & GameCanvas.UP_PRESSED)!=0){
			_PositionY += _StepPerSecond * aTime;
		}
		if ((aKeyStates & GameCanvas.LEFT_PRESSED)!=0){
			_PositionX -= _StepPerSecond * aTime;
		}
		if ((aKeyStates & GameCanvas.RIGHT_PRESSED)!=0){
			_PositionX += _StepPerSecond * aTime;
		}
		
		_GroupTranslation.setTranslation(_PositionX,_PositionY,_PositionZ);
	}
	
	private void moveModeRotate(long aTime, int aKeyStates){
		
		if ((aKeyStates & GameCanvas.DOWN_PRESSED)!=0){
			_AngleX -= _GradPerSecond * aTime;
			_Camera.setOrientation(_AngleX,1.0f,0.0f,0.0f);
		}
		if ((aKeyStates & GameCanvas.UP_PRESSED)!=0){
			_AngleX += _GradPerSecond * aTime;
			_Camera.setOrientation(_AngleX,1.0f,0.0f,0.0f);
		}
		if ((aKeyStates & GameCanvas.LEFT_PRESSED)!=0){
			_AngleY += _GradPerSecond * aTime;
			_GroupYRotation.setOrientation(_AngleY,0.0f,1.0f,0.0f);
		}
		if ((aKeyStates & GameCanvas.RIGHT_PRESSED)!=0){
			_AngleY -= _GradPerSecond * aTime;
			_GroupYRotation.setOrientation(_AngleY,0.0f,1.0f,0.0f);	
		}
	}
	
	private void moveModeZoom(long aTime, int aKeyStates){
		
		if ((aKeyStates & GameCanvas.DOWN_PRESSED)!=0){
			_PositionZ += _StepPerSecond * aTime;
		}
		if ((aKeyStates & GameCanvas.UP_PRESSED)!=0){
			_PositionZ -= _StepPerSecond * aTime;
		}
		
		_GroupTranslation.setTranslation(_PositionX,_PositionY,_PositionZ);
	}
	
	
	private void changeMode(){
		if (_mode < 3)
			 _mode++;
		else
			_mode = 0;
	}
	
	public String getModeInfo(){
		String lMode="";
		switch(_mode){
			case MODE_MOVE: lMode = "Move"; break;
			case MODE_ROTATE: lMode = "Rotate"; break;
			case MODE_ZOOM: lMode = "Zoom"; break;
			case MODE_ACTION: lMode = "Action"; break;
			default: lMode = "Undefined"; break;
		}
		
		return "Mode: " + lMode;
	}
	
	public String getPositionInfo(){
		return "Pos: x=" + _PositionX + 
		            " y=" + _PositionY +
					" z=" + _PositionZ;
	}
	
	public String getRotInfo(){
		return "Rot: x=" + _AngleX + 
		            " y=" + _AngleY;
	}
}

