/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */
import javax.microedition.m3g.Node;
import mgame.Math3D;

/**
 * Murmel - Version 2
 * @author Gerhard Vlkl
 */
public class SphereActor {
    
    public float[] velocity = {0.0f,0.0f,0.0f};
    public float[] position = {0.0f,0.0f,0.0f};
    private float[] localPosition = {0.0f,0.0f,0.0f};
    private float[] diffPosition = {0.0f,0.0f,0.0f};
    private float[] worldDiffPosition = {0.0f,0.0f,0.0f};
    
    public float mass = 0.1f; 
    public float radius = 0.25f;
    public Node node;
    
    public boolean isFalling = false;
    
    public SphereActor(Node node, Node myWorld) {
        this.node = node;
        
        Math3D.calulateRelativPosition(myWorld,node,worldDiffPosition);
        position[0] = worldDiffPosition[0];
        position[1] = worldDiffPosition[1];
        position[2] = worldDiffPosition[2];
    }
    
    public void addPostion(float[] diffPos){
        this.diffPosition[0] = diffPos[0];
        this.diffPosition[1] = diffPos[1];
        this.diffPosition[2] = diffPos[2];
        localPosition[0] += diffPos[0];
        localPosition[1] += diffPos[1];
        localPosition[2] += diffPos[2];
        position[0] += diffPos[0];
        position[1] += diffPos[1];
        position[2] += diffPos[2];
        node.setTranslation(localPosition[0],localPosition[1],localPosition[2]);
    }
    
    public void setLastPosition() {
        diffPosition[0] *= -1;
        diffPosition[1] *= -1;
        diffPosition[2] *= -1;
        addPostion(diffPosition);
    }

    void colliding() {
        setLastPosition();
        velocity[0] = 0.0f;
        velocity[1] = 0.0f;
        velocity[2] = 0.0f;
    }
}
