/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */
package mgame.ui;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.List;
import mgame.Game;

/**
 * Murmel - Version 2
 * @author Gerhard Vlkl
 */
public class MainMenuDialog extends List implements CommandListener,IMainMenuDialog{
    
    private UiManager uiManager;
    
  
    public MainMenuDialog(UiManager uiManager) {
        super("Hauptmen",List.IMPLICIT,new String[]{uiManager.NEW_GAME,uiManager.OPTIONS,
                                                     uiManager.HIGHSCORE,uiManager.HELP,
                                                     uiManager.ABOUT,uiManager.EXIT},null);
        this.uiManager = uiManager;
        
        setSelectCommand(new Command(uiManager.SELECT,Command.ITEM,1));
        setCommandListener(this);
    }

    public void commandAction(Command command, Displayable displayable) {
        if(displayable!=this) return;
        
        String selectedItem = this.getString(this.getSelectedIndex());
               
        if (selectedItem.equals(uiManager.NEW_GAME)){
            uiManager.showNewGameDialog();
        }else if (selectedItem.equals(uiManager.OPTIONS)){
            uiManager.showOptionDialog();
        }else if (selectedItem.equals(uiManager.HIGHSCORE)){
            uiManager.showHighScoreDialog();
        }else if (selectedItem.equals(uiManager.HELP)){
            uiManager.showHelpDialog();
        }else if (selectedItem.equals(uiManager.ABOUT)){
            uiManager.showAboutDialog();
        }else if (selectedItem.equals(uiManager.RESTART)){
            uiManager.getGame().restartGame();
        }else if (selectedItem.equals(uiManager.EXIT)){
            uiManager.getGame().exitGame();
        }
    }
    
    public void showNotify(){
        Game game = uiManager.getGame();
        if(game!=null && this.size()!=0){
            if(game.isRunning()){
                if (!this.getString(0).equals(uiManager.RESTART)){
                    this.insert(0,uiManager.RESTART,null);
                }
            }
            else{
                if(this.getString(0).equals(uiManager.RESTART)){
                    this.delete(0);
                }
            }
        }
    }
}
