/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */
import javax.microedition.lcdui.Canvas;
import javax.microedition.m3g.Camera;
import javax.microedition.m3g.Group;
import javax.microedition.m3g.Transform;

/**
 * Murmel - Version 2
 * @author Gerhard Vlkl
 */
public class CameraManager {
    
    private Group cameraGroup=null;
    
    public CameraManager(Camera camera, Canvas canvas){
        float[] projection = {0.0f, 0.0f, 0.0f, 0.0f};
        camera.getProjection(projection);
        camera.setPerspective(projection[0],  //Field of View
			      (float)canvas.getWidth()/(float)canvas.getHeight(), //Aspect Ratio
                              projection[2], //Near Clipping Plane
                              projection[3]); //Far Clipping Plane
        
        cameraGroup = new Group();
        Group p = (Group) camera.getParent();
        p.removeChild(camera);
        p.addChild(cameraGroup);
        cameraGroup.addChild(camera);
    }
    
    public void update(BoardActor board){
        Transform t = new Transform();
        t.postRotate(-1.0f*board.rotateX,1,0,0);
        t.postRotate(-1.0f*board.rotateZ,0,0,1);
        cameraGroup.setTransform(t);
    }
}
