/*
/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */
package mgame.ui;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.List;

/**
 * Murmel - Version 2
 * @author Gerhard Vlkl
 */
public class HelpMenuDialog extends List implements CommandListener {
    private UiManager uiManager;
    
    private static final String SELECT="Auswhl.";
    private static final String BACK="Zurck";
    
    private Command selectCommand=null;
    private Command backCommand=null;
    
    /** Creates a new instance of HelpMenuDialog */
    public HelpMenuDialog(UiManager uiManager, String[] chapters) {
        
        super("Anleitung",List.IMPLICIT,chapters,null);
        this.uiManager = uiManager;
        
        selectCommand = new Command(SELECT,Command.ITEM,1);
        addCommand(selectCommand);
        backCommand= new Command(BACK,Command.BACK,2);
        addCommand(backCommand);
        setCommandListener(this);
    }
    
    public void commandAction(Command command, Displayable displayable) {
        if (displayable!=this) return;
        
        if (command==selectCommand){
            int selectedItem = this.getSelectedIndex();
            uiManager.showHelpText(selectedItem);
        }else if(command==backCommand){
            uiManager.showMainDialog();
        }
    }
}
