/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */
package mgame.ui;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.StringItem;
import javax.microedition.lcdui.TextField;

/**
 * Murmel - Version 2
 * @author Gerhard Vlkl
 */
public class InputHighScoreDialog extends Form implements CommandListener{
    
    private UiManager uiManager;
    private long score;
    StringItem stringItem;
    TextField  inputField;
    private Command okCommand;
    
    /** Creates a new instance of InputHighScoreDialog */
    public InputHighScoreDialog(UiManager uiManager) {
        super("Neuer Highscore");
        this.uiManager = uiManager;
        
        stringItem = new StringItem("Ihr neuer Highscore",
                                    "", StringItem.PLAIN);
        inputField = new TextField("Name:","", 50, TextField.ANY);
       	append(stringItem);
        append(inputField);
        okCommand = new Command(uiManager.OK,Command.OK, 1);
        addCommand(okCommand);
        setCommandListener(this);
    }

    public void setScore(long newScore){
        score=newScore;
        stringItem.setText(String.valueOf(score));
    }
    public void commandAction(Command command, Displayable displayable) {
        
        if(displayable!=this) return;
        
	if (command == okCommand) {
	    uiManager.getGame().highScoreManager.addScore(score,inputField.getString());
	    uiManager.showHighScoreDialog();
	}
    }
    
}
