/*
 * Spiele programmieren mit Java ME
 * von (c) Gerhard Vlkl (Autor) 
 * Dpunkt Verlag; Auflage: 1 (April 2008) ISBN 389864488X 
 */
package mgame.ui;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.List;

/**
 * Murmel - Version 2
 * @author Gerhard Vlkl
 */
public class NewGameDialog extends List implements CommandListener {
    
    private UiManager uiManager = null;
    
    private static final String OPTION1="Level 1";
    private static final String OPTION2="Level 2";
    private static final String OPTION3="Level 3";
    private static final String SELECT="Auswhl.";
    private static final String BACK="Zurck";
    
    private Command selectCommand=null;
    private Command backCommand=null;
    
    public NewGameDialog(UiManager uiManager) {
        super("Neues Spiel",List.IMPLICIT,new String[]{OPTION1,OPTION2,OPTION3},null);
        this.uiManager = uiManager;
        
        selectCommand = new Command(SELECT,Command.ITEM,1);
        setSelectCommand(selectCommand);
        backCommand= new Command(BACK,Command.BACK,2);
        addCommand(backCommand);
        setCommandListener(this);
    }
    
    public void commandAction(Command command, Displayable displayable) {
        if (displayable!=this) return;
        
        if (command==selectCommand){
            String selectedItem = this.getString(this.getSelectedIndex());
            if (selectedItem==OPTION1){
                uiManager.getGame().setLevel(1);
                uiManager.getGame().startNewGame(false);
            }else if (selectedItem==OPTION2){
                uiManager.getGame().setLevel(2);
                uiManager.getGame().startNewGame(false);
            }else if (selectedItem==OPTION3){
                uiManager.getGame().setLevel(3);
                uiManager.getGame().startNewGame(false);
            }
        }else if(command==backCommand){
            uiManager.showMainDialog();
        }
    }
    
}
